enum ComparisonOperatorEnum
{
	equalTo,
	greaterThan,
	greatherThanOrEqualTo,
	lessThan,
	lessThanOrEqualTo
};


enum MeasuredOrDerivedDataTypeEnum
{
	humidityInformation,
	individualVehicleMeasurements,
	pollutionInformation,
	precipitationInformation,
	pressureInformation,
	radiationInformation,
	roadSurfaceConditionInformation,
	temperatureInformation,
	trafficConcentration,
	trafficFlow,
	trafficHeadway,
	trafficSpeed,
	trafficStatusInformation,
	travelTimeInformation,
	visibilityInformation,
	windInformation
};


class LengthCharacteristic
{
public:
	LengthCharacteristic(::ComparisonOperatorEnum comparisonOperator, float vehicleLength) : _comparisonOperator(comparisonOperator), _vehicleLength(vehicleLength)
	{
	}

	::ComparisonOperatorEnum comparisonOperator() const
	{
		return _comparisonOperator;
	}

	float vehicleLength() const
	{
		return _vehicleLength;
	}

private:
	::ComparisonOperatorEnum	_comparisonOperator;
	float						_vehicleLength;
};


class VehicleCharacteristics
{
public:
	VehicleCharacteristics(std::vector<::LengthCharacteristic> lengthCharacteristic) : _lengthCharacteristic(lengthCharacteristic)
	{
	}

//JOHN: ACCESS FUNCTIONS NEED TO BE IMPLEMENTED...

private:
	std::vector<::LengthCharacteristic> _lengthCharacteristic;
};


class MeasurementSpecificCharacteristics
{
public:
	MeasurementSpecificCharacteristics(float period, const std::string& specificLane, ::MeasuredOrDerivedDataTypeEnum specificMeasurementValueType, const ::VehicleCharacteristics& specificVehicleCharacteristics) : _period(period), _specificLane(specificLane), _specificMeasurementValueType(specificMeasurementValueType), _specificVehicleCharacteristics(specificVehicleCharacteristics)
	{
	}

//JOHN: ACCESS FUNCTIONS NEED TO BE IMPLEMENTED...

private:
	float							_period;
//	::LaneEnum						_specificLane;
// JOHN: Threat as string temporarily as we might pass this in the channel configuration...
	std::string						_specificLane;
	::MeasuredOrDerivedDataTypeEnum	_specificMeasurementValueType;
	::VehicleCharacteristics		_specificVehicleCharacteristics;
};


class MeasurementSiteRecord
{
public:
//JOHN: TO BE IMPLEMENTED...
	MeasurementSiteRecord(const std::string& id, const std::string& measurementSiteName, unsigned long long measurementSiteNumberOfLanes) : _id(id), _measurementSiteName(measurementSiteName), _measurementSiteNumberOfLanes(measurementSiteNumberOfLanes)
	{
	}

private:
	std::string			_id;
	const std::string&	_measurementSiteName;
	unsigned long long	_measurementSiteNumberOfLanes;
};


class MeasurementSiteTable
{
//JOHN: TO BE IMPLEMENTED...
public:

private:
	std::string								_measurementSiteTableIdentification;
	std::vector<::MeasurementSiteRecord>	_measurementSiteRecord;
};


class MeasurementSiteTablePublication
{
//JOHN: TO BE IMPLEMENTED...
public:
	MeasurementSiteTablePublication()
	{
	};

private:
};
